#!/usr/bin/tcl

proc p text {
puts stdout $text
}

proc sync {} {
puts .sync
}

proc clean {text} {
global result
regsub -all -- {\[[^\]]*\]} $text {} result
}

proc tts_set_punctuations text {
# p tts_set_punctuations
# p $text
}

proc q text {
global result
# p q
clean $text
p $result
}

proc r text {
p r
p $text
}

proc d {} {
# puts d
sync
}

proc tts_say text {
global result
# p tts_say
clean $text
p $result
sync
}

proc s {} {
# p s
# sync
}

proc tts_sync_state {a b c d e} {
# p tts_sync_state
# sync
}

proc l text {
# p l
p $text
sync
}

proc version {} {
p version
}

proc tts_set_speech_rate text {
# p tts_set_speech_rate
# p $text
}

proc tts_set_charcter_scale text {
p tts_set_character_scale
p $text
}

proc tts_split_caps text {
p tts_split_caps
p $text
}

proc tts_capitalize text {
p tts_capitalize
p $text
}

proc tts_allcaps_beep text {
p tts_allcaps_beep
p $text
}

proc tts_reset {} {
p tts_reset
}

proc tts_pause {} {
# p tts_pause
# puts .P0
}

proc tts_resume {} {
p tts_resume
}

# }}}
# {{{notes: 

#Simple notes player
#Uses stdio music player 

proc n {instrument pitch length {target 0} {step 5}} {
    global tts
    set f $tts(notes)
    if {$target == 0} {
        puts $f "n $instrument $pitch 127"
        select {} {} {} $length
        puts $f "x $instrument $pitch 127"
    } else {
        loop freq $pitch $target $step {
            puts $f "n $instrument $freq 127"
        }
        select {} {} {} $length
        loop freq $pitch $target $step {
            puts $f "x $instrument $freq 127"
        }
    }
    return 0
}

proc notes_shutdown  {} {
    global tts
    if {$tts(midi) == 0} return
    set notes $tts(notes)
    puts $notes "q\n"
    close $tts(notes)
    set tts(midi) 0
}

proc notes_initialize {} {
    global tts
    if {[info exists tts(midi)]
        && $tts(midi) == 1}  {
        puts stderr "Notes already initialized "
        return 1
    }
    set tts(midi) 0
    if {![file executable /usr/local/bin/stdiosynth]} {
        return
    }
    set result [catch {set tts(notes) [open "|stdiosynth " w]} err]
    if {$result != 0}  {
        puts stderr "$err: Notes not initialized --unable to start stdiosynth"
        return
    }
    fcntl $tts(notes) nobuf 1 
    set result [catch {n 1 60 .1 } err]
    if {$result == 0} {
        set tts(midi) 1
    } else {
        puts stderr "Error playing test note "
        set tts(midi) 0
    }
}

# produce tones via midi 

proc t  {{pitch 440} {duration 50}} {
    global tts
    if {$tts(midi)} {
            set inst 9
            set len .1
            set note [expr $pitch / 10]
            n $inst $note $len
    }
    return ""
}

proc sh  {{duration 50}} {
}

notes_initialize

commandloop

